/* Permissions.c generated by valac 0.44.3, the Vala compiler
 * generated from Permissions.vala, do not modify */

/*
* Copyright (c) 2016-2018 elementary LLC. <https://elementary.io>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1335 USA.
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

typedef enum  {
	PERMISSIONS_TYPE_USER,
	PERMISSIONS_TYPE_GROUP,
	PERMISSIONS_TYPE_OTHER
} PermissionsType;

#define PERMISSIONS_TYPE_TYPE (permissions_type_get_type ())
typedef enum  {
	PERMISSIONS_VALUE_READ,
	PERMISSIONS_VALUE_WRITE,
	PERMISSIONS_VALUE_EXE
} PermissionsValue;

#define PERMISSIONS_TYPE_VALUE (permissions_value_get_type ())
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

GType permissions_type_get_type (void) G_GNUC_CONST;
GType permissions_value_get_type (void) G_GNUC_CONST;
gboolean permissions_is_chmod_code (const gchar* str);

GType
permissions_type_get_type (void)
{
	static volatile gsize permissions_type_type_id__volatile = 0;
	if (g_once_init_enter (&permissions_type_type_id__volatile)) {
		static const GEnumValue values[] = {{PERMISSIONS_TYPE_USER, "PERMISSIONS_TYPE_USER", "user"}, {PERMISSIONS_TYPE_GROUP, "PERMISSIONS_TYPE_GROUP", "group"}, {PERMISSIONS_TYPE_OTHER, "PERMISSIONS_TYPE_OTHER", "other"}, {0, NULL, NULL}};
		GType permissions_type_type_id;
		permissions_type_type_id = g_enum_register_static ("PermissionsType", values);
		g_once_init_leave (&permissions_type_type_id__volatile, permissions_type_type_id);
	}
	return permissions_type_type_id__volatile;
}

GType
permissions_value_get_type (void)
{
	static volatile gsize permissions_value_type_id__volatile = 0;
	if (g_once_init_enter (&permissions_value_type_id__volatile)) {
		static const GEnumValue values[] = {{PERMISSIONS_VALUE_READ, "PERMISSIONS_VALUE_READ", "read"}, {PERMISSIONS_VALUE_WRITE, "PERMISSIONS_VALUE_WRITE", "write"}, {PERMISSIONS_VALUE_EXE, "PERMISSIONS_VALUE_EXE", "exe"}, {0, NULL, NULL}};
		GType permissions_value_type_id;
		permissions_value_type_id = g_enum_register_static ("PermissionsValue", values);
		g_once_init_leave (&permissions_value_type_id__volatile, permissions_value_type_id);
	}
	return permissions_value_type_id__volatile;
}

gboolean
permissions_is_chmod_code (const gchar* str)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 33 "../src/Utils/Permissions.vala"
	g_return_val_if_fail (str != NULL, FALSE);
#line 83 "Permissions.c"
	{
		GRegex* regex = NULL;
		GRegex* _tmp0_;
#line 35 "../src/Utils/Permissions.vala"
		_tmp0_ = g_regex_new ("^[0-7]{3}$", 0, 0, &_inner_error0_);
#line 35 "../src/Utils/Permissions.vala"
		regex = _tmp0_;
#line 35 "../src/Utils/Permissions.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 93 "Permissions.c"
			gboolean _tmp1_ = FALSE;
#line 35 "../src/Utils/Permissions.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 97 "Permissions.c"
				goto __catch17_g_regex_error;
			}
#line 35 "../src/Utils/Permissions.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 35 "../src/Utils/Permissions.vala"
			g_clear_error (&_inner_error0_);
#line 35 "../src/Utils/Permissions.vala"
			return _tmp1_;
#line 106 "Permissions.c"
		}
#line 36 "../src/Utils/Permissions.vala"
		if (g_regex_match (regex, str, 0, NULL)) {
#line 37 "../src/Utils/Permissions.vala"
			result = TRUE;
#line 37 "../src/Utils/Permissions.vala"
			_g_regex_unref0 (regex);
#line 37 "../src/Utils/Permissions.vala"
			return result;
#line 116 "Permissions.c"
		}
#line 34 "../src/Utils/Permissions.vala"
		_g_regex_unref0 (regex);
#line 120 "Permissions.c"
	}
	goto __finally17;
	__catch17_g_regex_error:
	{
		GError* e = NULL;
#line 34 "../src/Utils/Permissions.vala"
		e = _inner_error0_;
#line 34 "../src/Utils/Permissions.vala"
		_inner_error0_ = NULL;
#line 40 "../src/Utils/Permissions.vala"
		g_assert_not_reached ();
#line 34 "../src/Utils/Permissions.vala"
		_g_error_free0 (e);
#line 134 "Permissions.c"
	}
	__finally17:
#line 34 "../src/Utils/Permissions.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "Permissions.c"
		gboolean _tmp2_ = FALSE;
#line 34 "../src/Utils/Permissions.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 34 "../src/Utils/Permissions.vala"
		g_clear_error (&_inner_error0_);
#line 34 "../src/Utils/Permissions.vala"
		return _tmp2_;
#line 147 "Permissions.c"
	}
#line 43 "../src/Utils/Permissions.vala"
	result = FALSE;
#line 43 "../src/Utils/Permissions.vala"
	return result;
#line 153 "Permissions.c"
}

