/* PermissionButton.c generated by valac 0.44.3, the Vala compiler
 * generated from PermissionButton.vala, do not modify */

/*
* Copyright (c) 2016-2018 elementary LLC. <https://elementary.io>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation, Inc.,; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1335 USA.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#define TYPE_PERMISSION_BUTTON (permission_button_get_type ())
#define PERMISSION_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PERMISSION_BUTTON, PermissionButton))
#define PERMISSION_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PERMISSION_BUTTON, PermissionButtonClass))
#define IS_PERMISSION_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PERMISSION_BUTTON))
#define IS_PERMISSION_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PERMISSION_BUTTON))
#define PERMISSION_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PERMISSION_BUTTON, PermissionButtonClass))

typedef struct _PermissionButton PermissionButton;
typedef struct _PermissionButtonClass PermissionButtonClass;
typedef struct _PermissionButtonPrivate PermissionButtonPrivate;
typedef enum  {
	PERMISSIONS_TYPE_USER,
	PERMISSIONS_TYPE_GROUP,
	PERMISSIONS_TYPE_OTHER
} PermissionsType;

#define PERMISSIONS_TYPE_TYPE (permissions_type_get_type ())
enum  {
	PERMISSION_BUTTON_0_PROPERTY,
	PERMISSION_BUTTON_PERMISSION_TYPE_PROPERTY,
	PERMISSION_BUTTON_NUM_PROPERTIES
};
static GParamSpec* permission_button_properties[PERMISSION_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	PERMISSIONS_VALUE_READ,
	PERMISSIONS_VALUE_WRITE,
	PERMISSIONS_VALUE_EXE
} PermissionsValue;

#define PERMISSIONS_TYPE_VALUE (permissions_value_get_type ())

struct _PermissionButton {
	GtkGrid parent_instance;
	PermissionButtonPrivate * priv;
	GtkToggleButton* btn_read;
	GtkToggleButton* btn_write;
	GtkToggleButton* btn_exe;
};

struct _PermissionButtonClass {
	GtkGridClass parent_class;
};

struct _PermissionButtonPrivate {
	PermissionsType _permission_type;
	mode_t* vfs_perms;
	gint vfs_perms_length1;
	gint vfs_perms_length2;
};

static gint PermissionButton_private_offset;
static gpointer permission_button_parent_class = NULL;

GType permission_button_get_type (void) G_GNUC_CONST;
GType permissions_type_get_type (void) G_GNUC_CONST;
PermissionButton* permission_button_new (PermissionsType permission_type);
PermissionButton* permission_button_construct (GType object_type,
                                               PermissionsType permission_type);
void permission_button_update_buttons (PermissionButton* self,
                                       guint32 permissions);
PermissionsType permission_button_get_permission_type (PermissionButton* self);
static void permission_button_set_permission_type (PermissionButton* self,
                                            PermissionsType value);
static GObject * permission_button_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
GType permissions_value_get_type (void) G_GNUC_CONST;
static void permission_button_finalize (GObject * obj);
static void _vala_permission_button_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_permission_button_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
permission_button_get_instance_private (PermissionButton* self)
{
	return G_STRUCT_MEMBER_P (self, PermissionButton_private_offset);
}

PermissionButton*
permission_button_construct (GType object_type,
                             PermissionsType permission_type)
{
	PermissionButton * self = NULL;
#line 34 "../src/View/Widgets/PermissionButton.vala"
	self = (PermissionButton*) g_object_new (object_type, "permission-type", permission_type, NULL);
#line 33 "../src/View/Widgets/PermissionButton.vala"
	return self;
#line 124 "PermissionButton.c"
}

PermissionButton*
permission_button_new (PermissionsType permission_type)
{
#line 33 "../src/View/Widgets/PermissionButton.vala"
	return permission_button_construct (TYPE_PERMISSION_BUTTON, permission_type);
#line 132 "PermissionButton.c"
}

void
permission_button_update_buttons (PermissionButton* self,
                                  guint32 permissions)
{
	mode_t* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	PermissionsType _tmp1_;
	mode_t _tmp2_;
	mode_t* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	PermissionsType _tmp6_;
	mode_t _tmp7_;
	mode_t* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	PermissionsType _tmp11_;
	mode_t _tmp12_;
#line 57 "../src/View/Widgets/PermissionButton.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/View/Widgets/PermissionButton.vala"
	_tmp0_ = self->priv->vfs_perms;
#line 58 "../src/View/Widgets/PermissionButton.vala"
	_tmp0__length1 = self->priv->vfs_perms_length1;
#line 58 "../src/View/Widgets/PermissionButton.vala"
	_tmp0__length2 = self->priv->vfs_perms_length2;
#line 58 "../src/View/Widgets/PermissionButton.vala"
	_tmp1_ = self->priv->_permission_type;
#line 58 "../src/View/Widgets/PermissionButton.vala"
	_tmp2_ = _tmp0_[(_tmp1_ * _tmp0__length2) + 0];
#line 58 "../src/View/Widgets/PermissionButton.vala"
	if ((permissions & _tmp2_) != ((guint32) 0)) {
#line 168 "PermissionButton.c"
		GtkToggleButton* _tmp3_;
#line 59 "../src/View/Widgets/PermissionButton.vala"
		_tmp3_ = self->btn_read;
#line 59 "../src/View/Widgets/PermissionButton.vala"
		gtk_toggle_button_set_active (_tmp3_, TRUE);
#line 174 "PermissionButton.c"
	} else {
		GtkToggleButton* _tmp4_;
#line 61 "../src/View/Widgets/PermissionButton.vala"
		_tmp4_ = self->btn_read;
#line 61 "../src/View/Widgets/PermissionButton.vala"
		gtk_toggle_button_set_active (_tmp4_, FALSE);
#line 181 "PermissionButton.c"
	}
#line 64 "../src/View/Widgets/PermissionButton.vala"
	_tmp5_ = self->priv->vfs_perms;
#line 64 "../src/View/Widgets/PermissionButton.vala"
	_tmp5__length1 = self->priv->vfs_perms_length1;
#line 64 "../src/View/Widgets/PermissionButton.vala"
	_tmp5__length2 = self->priv->vfs_perms_length2;
#line 64 "../src/View/Widgets/PermissionButton.vala"
	_tmp6_ = self->priv->_permission_type;
#line 64 "../src/View/Widgets/PermissionButton.vala"
	_tmp7_ = _tmp5_[(_tmp6_ * _tmp5__length2) + 1];
#line 64 "../src/View/Widgets/PermissionButton.vala"
	if ((permissions & _tmp7_) != ((guint32) 0)) {
#line 195 "PermissionButton.c"
		GtkToggleButton* _tmp8_;
#line 65 "../src/View/Widgets/PermissionButton.vala"
		_tmp8_ = self->btn_write;
#line 65 "../src/View/Widgets/PermissionButton.vala"
		gtk_toggle_button_set_active (_tmp8_, TRUE);
#line 201 "PermissionButton.c"
	} else {
		GtkToggleButton* _tmp9_;
#line 67 "../src/View/Widgets/PermissionButton.vala"
		_tmp9_ = self->btn_write;
#line 67 "../src/View/Widgets/PermissionButton.vala"
		gtk_toggle_button_set_active (_tmp9_, FALSE);
#line 208 "PermissionButton.c"
	}
#line 70 "../src/View/Widgets/PermissionButton.vala"
	_tmp10_ = self->priv->vfs_perms;
#line 70 "../src/View/Widgets/PermissionButton.vala"
	_tmp10__length1 = self->priv->vfs_perms_length1;
#line 70 "../src/View/Widgets/PermissionButton.vala"
	_tmp10__length2 = self->priv->vfs_perms_length2;
#line 70 "../src/View/Widgets/PermissionButton.vala"
	_tmp11_ = self->priv->_permission_type;
#line 70 "../src/View/Widgets/PermissionButton.vala"
	_tmp12_ = _tmp10_[(_tmp11_ * _tmp10__length2) + 2];
#line 70 "../src/View/Widgets/PermissionButton.vala"
	if ((permissions & _tmp12_) != ((guint32) 0)) {
#line 222 "PermissionButton.c"
		GtkToggleButton* _tmp13_;
#line 71 "../src/View/Widgets/PermissionButton.vala"
		_tmp13_ = self->btn_exe;
#line 71 "../src/View/Widgets/PermissionButton.vala"
		gtk_toggle_button_set_active (_tmp13_, TRUE);
#line 228 "PermissionButton.c"
	} else {
		GtkToggleButton* _tmp14_;
#line 73 "../src/View/Widgets/PermissionButton.vala"
		_tmp14_ = self->btn_exe;
#line 73 "../src/View/Widgets/PermissionButton.vala"
		gtk_toggle_button_set_active (_tmp14_, FALSE);
#line 235 "PermissionButton.c"
	}
}

PermissionsType
permission_button_get_permission_type (PermissionButton* self)
{
	PermissionsType result;
	PermissionsType _tmp0_;
#line 25 "../src/View/Widgets/PermissionButton.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 25 "../src/View/Widgets/PermissionButton.vala"
	_tmp0_ = self->priv->_permission_type;
#line 25 "../src/View/Widgets/PermissionButton.vala"
	result = _tmp0_;
#line 25 "../src/View/Widgets/PermissionButton.vala"
	return result;
#line 252 "PermissionButton.c"
}

static void
permission_button_set_permission_type (PermissionButton* self,
                                       PermissionsType value)
{
#line 25 "../src/View/Widgets/PermissionButton.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/View/Widgets/PermissionButton.vala"
	if (permission_button_get_permission_type (self) != value) {
#line 25 "../src/View/Widgets/PermissionButton.vala"
		self->priv->_permission_type = value;
#line 25 "../src/View/Widgets/PermissionButton.vala"
		g_object_notify_by_pspec ((GObject *) self, permission_button_properties[PERMISSION_BUTTON_PERMISSION_TYPE_PROPERTY]);
#line 267 "PermissionButton.c"
	}
}

static GObject *
permission_button_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PermissionButton * self;
	GtkToggleButton* _tmp0_;
	GtkToggleButton* _tmp1_;
	PermissionsType _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkToggleButton* _tmp4_;
	GtkToggleButton* _tmp5_;
	PermissionsType _tmp6_;
	GtkToggleButton* _tmp7_;
	GtkToggleButton* _tmp8_;
	GtkToggleButton* _tmp9_;
	PermissionsType _tmp10_;
	GtkToggleButton* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkToggleButton* _tmp13_;
	GtkToggleButton* _tmp14_;
	GtkToggleButton* _tmp15_;
#line 37 "../src/View/Widgets/PermissionButton.vala"
	parent_class = G_OBJECT_CLASS (permission_button_parent_class);
#line 37 "../src/View/Widgets/PermissionButton.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/View/Widgets/PermissionButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PERMISSION_BUTTON, PermissionButton);
#line 38 "../src/View/Widgets/PermissionButton.vala"
	_tmp0_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("Read"));
#line 38 "../src/View/Widgets/PermissionButton.vala"
	g_object_ref_sink (_tmp0_);
#line 38 "../src/View/Widgets/PermissionButton.vala"
	_g_object_unref0 (self->btn_read);
#line 38 "../src/View/Widgets/PermissionButton.vala"
	self->btn_read = _tmp0_;
#line 39 "../src/View/Widgets/PermissionButton.vala"
	_tmp1_ = self->btn_read;
#line 39 "../src/View/Widgets/PermissionButton.vala"
	_tmp2_ = self->priv->_permission_type;
#line 39 "../src/View/Widgets/PermissionButton.vala"
	g_object_set_data_full ((GObject*) _tmp1_, "permissiontype", (gpointer) ((gintptr) _tmp2_), NULL);
#line 40 "../src/View/Widgets/PermissionButton.vala"
	_tmp3_ = self->btn_read;
#line 40 "../src/View/Widgets/PermissionButton.vala"
	g_object_set_data_full ((GObject*) _tmp3_, "permissionvalue", (gpointer) ((gintptr) PERMISSIONS_VALUE_READ), NULL);
#line 42 "../src/View/Widgets/PermissionButton.vala"
	_tmp4_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("Write"));
#line 42 "../src/View/Widgets/PermissionButton.vala"
	g_object_ref_sink (_tmp4_);
#line 42 "../src/View/Widgets/PermissionButton.vala"
	_g_object_unref0 (self->btn_write);
#line 42 "../src/View/Widgets/PermissionButton.vala"
	self->btn_write = _tmp4_;
#line 43 "../src/View/Widgets/PermissionButton.vala"
	_tmp5_ = self->btn_write;
#line 43 "../src/View/Widgets/PermissionButton.vala"
	_tmp6_ = self->priv->_permission_type;
#line 43 "../src/View/Widgets/PermissionButton.vala"
	g_object_set_data_full ((GObject*) _tmp5_, "permissiontype", (gpointer) ((gintptr) _tmp6_), NULL);
#line 44 "../src/View/Widgets/PermissionButton.vala"
	_tmp7_ = self->btn_write;
#line 44 "../src/View/Widgets/PermissionButton.vala"
	g_object_set_data_full ((GObject*) _tmp7_, "permissionvalue", (gpointer) ((gintptr) PERMISSIONS_VALUE_WRITE), NULL);
#line 46 "../src/View/Widgets/PermissionButton.vala"
	_tmp8_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("Execute"));
#line 46 "../src/View/Widgets/PermissionButton.vala"
	g_object_ref_sink (_tmp8_);
#line 46 "../src/View/Widgets/PermissionButton.vala"
	_g_object_unref0 (self->btn_exe);
#line 46 "../src/View/Widgets/PermissionButton.vala"
	self->btn_exe = _tmp8_;
#line 47 "../src/View/Widgets/PermissionButton.vala"
	_tmp9_ = self->btn_exe;
#line 47 "../src/View/Widgets/PermissionButton.vala"
	_tmp10_ = self->priv->_permission_type;
#line 47 "../src/View/Widgets/PermissionButton.vala"
	g_object_set_data_full ((GObject*) _tmp9_, "permissiontype", (gpointer) ((gintptr) _tmp10_), NULL);
#line 48 "../src/View/Widgets/PermissionButton.vala"
	_tmp11_ = self->btn_exe;
#line 48 "../src/View/Widgets/PermissionButton.vala"
	g_object_set_data_full ((GObject*) _tmp11_, "permissionvalue", (gpointer) ((gintptr) PERMISSIONS_VALUE_EXE), NULL);
#line 50 "../src/View/Widgets/PermissionButton.vala"
	gtk_grid_set_column_homogeneous ((GtkGrid*) self, TRUE);
#line 51 "../src/View/Widgets/PermissionButton.vala"
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 51 "../src/View/Widgets/PermissionButton.vala"
	gtk_style_context_add_class (_tmp12_, GTK_STYLE_CLASS_LINKED);
#line 52 "../src/View/Widgets/PermissionButton.vala"
	_tmp13_ = self->btn_read;
#line 52 "../src/View/Widgets/PermissionButton.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp13_);
#line 53 "../src/View/Widgets/PermissionButton.vala"
	_tmp14_ = self->btn_write;
#line 53 "../src/View/Widgets/PermissionButton.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp14_);
#line 54 "../src/View/Widgets/PermissionButton.vala"
	_tmp15_ = self->btn_exe;
#line 54 "../src/View/Widgets/PermissionButton.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp15_);
#line 37 "../src/View/Widgets/PermissionButton.vala"
	return obj;
#line 375 "PermissionButton.c"
}

static void
permission_button_class_init (PermissionButtonClass * klass,
                              gpointer klass_data)
{
#line 20 "../src/View/Widgets/PermissionButton.vala"
	permission_button_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/View/Widgets/PermissionButton.vala"
	g_type_class_adjust_private_offset (klass, &PermissionButton_private_offset);
#line 20 "../src/View/Widgets/PermissionButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_permission_button_get_property;
#line 20 "../src/View/Widgets/PermissionButton.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_permission_button_set_property;
#line 20 "../src/View/Widgets/PermissionButton.vala"
	G_OBJECT_CLASS (klass)->constructor = permission_button_constructor;
#line 20 "../src/View/Widgets/PermissionButton.vala"
	G_OBJECT_CLASS (klass)->finalize = permission_button_finalize;
#line 20 "../src/View/Widgets/PermissionButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PERMISSION_BUTTON_PERMISSION_TYPE_PROPERTY, permission_button_properties[PERMISSION_BUTTON_PERMISSION_TYPE_PROPERTY] = g_param_spec_enum ("permission-type", "permission-type", "permission-type", PERMISSIONS_TYPE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 396 "PermissionButton.c"
}

static void
permission_button_instance_init (PermissionButton * self,
                                 gpointer klass)
{
	mode_t* _tmp0_;
#line 20 "../src/View/Widgets/PermissionButton.vala"
	self->priv = permission_button_get_instance_private (self);
#line 27 "../src/View/Widgets/PermissionButton.vala"
	_tmp0_ = g_new0 (mode_t, 3 * 3);
#line 27 "../src/View/Widgets/PermissionButton.vala"
	_tmp0_[0] = S_IRUSR;
#line 27 "../src/View/Widgets/PermissionButton.vala"
	_tmp0_[1] = S_IWUSR;
#line 27 "../src/View/Widgets/PermissionButton.vala"
	_tmp0_[2] = S_IXUSR;
#line 27 "../src/View/Widgets/PermissionButton.vala"
	_tmp0_[3] = S_IRGRP;
#line 27 "../src/View/Widgets/PermissionButton.vala"
	_tmp0_[4] = S_IWGRP;
#line 27 "../src/View/Widgets/PermissionButton.vala"
	_tmp0_[5] = S_IXGRP;
#line 27 "../src/View/Widgets/PermissionButton.vala"
	_tmp0_[6] = S_IROTH;
#line 27 "../src/View/Widgets/PermissionButton.vala"
	_tmp0_[7] = S_IWOTH;
#line 27 "../src/View/Widgets/PermissionButton.vala"
	_tmp0_[8] = S_IXOTH;
#line 27 "../src/View/Widgets/PermissionButton.vala"
	self->priv->vfs_perms = _tmp0_;
#line 27 "../src/View/Widgets/PermissionButton.vala"
	self->priv->vfs_perms_length1 = 3;
#line 27 "../src/View/Widgets/PermissionButton.vala"
	self->priv->vfs_perms_length2 = 3;
#line 432 "PermissionButton.c"
}

static void
permission_button_finalize (GObject * obj)
{
	PermissionButton * self;
#line 20 "../src/View/Widgets/PermissionButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PERMISSION_BUTTON, PermissionButton);
#line 21 "../src/View/Widgets/PermissionButton.vala"
	_g_object_unref0 (self->btn_read);
#line 22 "../src/View/Widgets/PermissionButton.vala"
	_g_object_unref0 (self->btn_write);
#line 23 "../src/View/Widgets/PermissionButton.vala"
	_g_object_unref0 (self->btn_exe);
#line 27 "../src/View/Widgets/PermissionButton.vala"
	self->priv->vfs_perms = (g_free (self->priv->vfs_perms), NULL);
#line 20 "../src/View/Widgets/PermissionButton.vala"
	G_OBJECT_CLASS (permission_button_parent_class)->finalize (obj);
#line 451 "PermissionButton.c"
}

GType
permission_button_get_type (void)
{
	static volatile gsize permission_button_type_id__volatile = 0;
	if (g_once_init_enter (&permission_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PermissionButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) permission_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PermissionButton), 0, (GInstanceInitFunc) permission_button_instance_init, NULL };
		GType permission_button_type_id;
		permission_button_type_id = g_type_register_static (gtk_grid_get_type (), "PermissionButton", &g_define_type_info, 0);
		PermissionButton_private_offset = g_type_add_instance_private (permission_button_type_id, sizeof (PermissionButtonPrivate));
		g_once_init_leave (&permission_button_type_id__volatile, permission_button_type_id);
	}
	return permission_button_type_id__volatile;
}

static void
_vala_permission_button_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	PermissionButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PERMISSION_BUTTON, PermissionButton);
#line 20 "../src/View/Widgets/PermissionButton.vala"
	switch (property_id) {
#line 20 "../src/View/Widgets/PermissionButton.vala"
		case PERMISSION_BUTTON_PERMISSION_TYPE_PROPERTY:
#line 20 "../src/View/Widgets/PermissionButton.vala"
		g_value_set_enum (value, permission_button_get_permission_type (self));
#line 20 "../src/View/Widgets/PermissionButton.vala"
		break;
#line 484 "PermissionButton.c"
		default:
#line 20 "../src/View/Widgets/PermissionButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/View/Widgets/PermissionButton.vala"
		break;
#line 490 "PermissionButton.c"
	}
}

static void
_vala_permission_button_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	PermissionButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PERMISSION_BUTTON, PermissionButton);
#line 20 "../src/View/Widgets/PermissionButton.vala"
	switch (property_id) {
#line 20 "../src/View/Widgets/PermissionButton.vala"
		case PERMISSION_BUTTON_PERMISSION_TYPE_PROPERTY:
#line 20 "../src/View/Widgets/PermissionButton.vala"
		permission_button_set_permission_type (self, g_value_get_enum (value));
#line 20 "../src/View/Widgets/PermissionButton.vala"
		break;
#line 510 "PermissionButton.c"
		default:
#line 20 "../src/View/Widgets/PermissionButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/View/Widgets/PermissionButton.vala"
		break;
#line 516 "PermissionButton.c"
	}
}

